<!DOCTYPE html>
<html lang="en">

<head>
    <title>task 41.55 Filter Users</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <!-- Import Datatable sau jquery -->
    <!-- Import them style bootstrap cho datatable -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

</head>
<script>
    "use strict";
    $(document).ready(function () {
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        var gId;
        var gOrderCode;
        var gDataOrders; //khai báo biến array để chứa data order

        var gPizaaSize = ["Small", "Medium", "Large"]; //khai báo array chứa giá trị kích cỡ của pizza size
        const gORDER = ["orderCode", "kichCo", "loaiPizza", "idLoaiNuocUong", "thanhTien", "hoTen", "soDienThoai", "trangThai", "action"];
        const gCOLUMN_ORDER_CODE = 0;
        const gCOLUMN_KICH_CO = 1;
        const gCOLUMN_LOAI_PIZZA = 2;
        const gCOLUMN_ID_LOAI_NUOC_DUNG = 3;
        const gCOLUMN_THANH_TIEN = 4;
        const gCOLUMN_HO_TEN = 5;
        const gCOLUMN_SO_DIEN_THOAI = 6;
        const gCOLUMN_TRANG_THAI = 7;
        const gCOLUMN_ACTION = 8;
        //định nghĩa table - chưa có data
        var gDataTable = $("#table-order").DataTable({
            "columns": [
                { "data": gORDER[gCOLUMN_ORDER_CODE] },
                { "data": gORDER[gCOLUMN_KICH_CO] },
                { "data": gORDER[gCOLUMN_LOAI_PIZZA] },
                { "data": gORDER[gCOLUMN_ID_LOAI_NUOC_DUNG] },
                { "data": gORDER[gCOLUMN_THANH_TIEN] },
                { "data": gORDER[gCOLUMN_HO_TEN] },
                { "data": gORDER[gCOLUMN_SO_DIEN_THOAI] },
                { "data": gORDER[gCOLUMN_TRANG_THAI] },
                { "data": gORDER[gCOLUMN_ACTION] }
            ],
            //ghi đè nội dung cột action, chuyển thành button Chi tiết
            "columnDefs": [
                {
                    "targets": gCOLUMN_ACTION,
                    "defaultContent": "<button class='btn-detail btn btn-success'>Chi tiết</button>"
                }
            ]
        });

        /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
        onPageLoading()

        getDrinkList()

        getPizzaSizeList(gPizaaSize)
        $("#table-order").on('click', ".btn-detail", function () {
            onBtnChiTietClick(this);
        });
        // gán sự kiện cho nút lọc dữ liệu
        $("#btn-filter").on('click', function () {
            onBtnFilterDataClick();
        })
        // gán sự kiện cho nút Confirm trên modal
        $("#btn-confirm").on('click', function () {
            onBtnConfirmClick();
        })
        // gán sự kiện cho nút Confirm trên modal
        $("#btn-cancel").on('click', function () {
            onBtnCancelClick();
        })



        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        function onPageLoading() {
            getAllOrder()

        }
        // hàm nut confirm trên modal
        function onBtnConfirmClick(){
            var vConfirm = {
                trangThai: "confirmed"
            }

            callUpdateOrder(vConfirm)
        }
                // hàm nut cancel trên modal
        function onBtnCancelClick(){
            var vCancel = {
                trangThai: "cancel"
            }

            callUpdateOrder(vCancel)
        }
        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
        // hàm lọc dữ liệu
        function onBtnFilterDataClick() {
            var vStatus = $("#sel-status").val()
            var vPizzaType = $("#sel-pizza").val()

            var vResultFiler = gDataOrders.filter((item) =>
                (item.trangThai.toLowerCase() == vStatus.toLowerCase() || vStatus === "all") &&
                (item.loaiPizza.toLowerCase() == vPizzaType.toLowerCase() || vPizzaType === "all")
            )
            console.log(vResultFiler)
            loadDataToTable(vResultFiler)
        }
        //
        
        // hàm call API Updtate order
        function callUpdateOrder(paramOjb){
            $.ajax({
                url: "http://203.171.20.210:8080/devcamp-pizza365/orders/" + gId,
                type: 'PUT',
                contentType: 'application/json',
                data: JSON.stringify(paramOjb), //chuyển obj thành json string
                success: function (responseObj) {
                    console.log(responseObj);
                    getAllOrder()
                    $("#order-modal").modal("hide");
                    
                },
                error: function (ajaxContext) {
                    alert(ajaxContext.responseText);
                }
            });

        }
        //  //hàm gọi api order by orderCode
        function getAjaxDetailOrder(paramOrderCode) {
            $.ajax({
                url: "http://203.171.20.210:8080/devcamp-pizza365/orders/" + paramOrderCode,
                dataType: "json",
                type: "GET",
                success: function (paramOrder) {
                    console.log(paramOrder);
                    //gọi hàm hiển thị data order lên modal
                    handleOrderDetail(paramOrder);
                },
                error: function (ajaxContext) {
                    alert(ajaxContext.responseText);
                }
            });

        }
        //hàm gọi api get drink list
        function getDrinkList() {
            $.ajax({
                url: "http://203.171.20.210:8080/devcamp-pizza365/drinks",
                type: "GET",
                success: function (res) {
                    handleDrinkList(res);
                },
                error: function (ajaxContext) {
                    alert(ajaxContext.responseText);
                }
            });
        }
        //hàm tạo option cho select drink tren modal
        function handleDrinkList(paramDrinks) {
            $.each(paramDrinks, function (i, item) {
                $("#select-drink").append($("<option>", {
                    text: item.tenNuocUong,
                    value: item.maNuocUong
                }))
            });
        }
        //hàm tạo option cho select pizza size
        function getPizzaSizeList(paramPizza) {

            $.each(paramPizza, function (i, item) {
                $("#select-pizzasize").append($("<option>", {
                    text: item,
                    value: item.toLowerCase()
                }));
            });
        }
        // hàm call API all Order
        function getAllOrder(){
            $.ajax({
                url: "http://203.171.20.210:8080/devcamp-pizza365/orders",
                type: "GET",
                dataType: "json",
                success: function (res) {
                    gDataOrders = res;
                    console.log(gDataOrders);
                    loadDataToTable(res); //gọi hàm load data vào table
                },
                error: function (err) {
                    console.assert(err.responseText);
                }
            });
        }

        // hàm nút chi tiết
        function onBtnChiTietClick(paramButton) {
            var vRowSelect = $(paramButton).closest("tr")
            var vDataRow = gDataTable.row(vRowSelect).data()
            gOrderCode = vDataRow.orderCode
            gId = vDataRow.id
            console.log("ID được chọn là: " + gId)
            console.log("OrderCode được chọn là: " + gOrderCode)
            // hàm Call API chi tiết order by orderCode
            getAjaxDetailOrder(gOrderCode)
            $("#order-modal").modal("show"); // hiển thị modal order lê
        }
        //hàm đổ data vào modal
        function handleOrderDetail(paramResponse) {
            $("#inp-ordercode").val(paramResponse.orderCode);
            $("#select-pizzasize").val(paramResponse.kichCo.toLowerCase());
            $("#inp-duongkinh").val(paramResponse.duongKinh);
            $("#inp-suon").val(paramResponse.suon);
            $("#inp-salad").val(paramResponse.salad);
            $("#inp-pizzatype").val(paramResponse.loaiPizza);
            $("#inp-idvoucher").val(paramResponse.idVourcher);
            $("#inp-thanhtien").val(paramResponse.thanhTien);
            $("#inp-giamgia").val(paramResponse.giamGia);
            $("#select-drink").val(paramResponse.idLoaiNuocUong);
            $("#inp-soluongdrink").val(paramResponse.soLuongNuoc);
            $("#inp-hoten").val(paramResponse.hoTen);
            $("#inp-email").val(paramResponse.email);
            $("#inp-phone").val(paramResponse.soDienThoai);
            $("#inp-address").val(paramResponse.diaChi);
            $("#inp-message").val(paramResponse.loiNhan);
            $("#inp-orderday").val(paramResponse.ngayTao);
            $("#inp-updatedate").val(paramResponse.ngayCapNhat);
        }
        // load Data lên table
        function loadDataToTable(paramData) {
            gDataTable.clear()
            gDataTable.rows.add(paramData)
            gDataTable.draw()
        }


    });
</script>

<body>
    <div class="container">
        <h2 style="text-align: center;">Danh sách đơn hàng</h2>
        <div class="jumbotron mt-3">

            <div class="form-row">
                <label class="col-sm-2 col-form-label text-center">Trạng thái order</label>
                <div class="col-sm-3">
                    <select name="" id="sel-status" class="form-control">
                        <option value="all">All</option>
                        <option value="open">Open</option>
                        <option value="confirmed">Confirmed</option>
                        <option value="cancel">Cancel</option>

                    </select>
                </div>
                <label class="col-sm-2 col-form-label text-center">Loại Pizza</label>
                <div class="col-sm-3">
                    <select name="" id="sel-pizza" class="form-control">
                        <option value="all">All</option>
                        <option value="hawaii">Hawaii</option>
                        <option value="bacon">Bacon</option>
                        <option value="seafood">Seafood</option>

                    </select>
                </div>
                <div class="col-sm-2">
                    <button class="btn btn-primary w-100" id="btn-filter"> Lọc</button>
                </div>
            </div>

        </div>
    </div>
    <div class="container-fluid">
        <table class="table table-bordered table-striped table-hover" id="table-order">
            <thead class="thead-dark">
                <tr>
                    <th>Order Code</th>
                    <th>Kích cỡ Combo</th>
                    <th>Loại Pizza</th>
                    <th>Nước uống</th>
                    <th>Thành tiền</th>
                    <th>Họ và tên</th>
                    <th>Số điện thoại</th>
                    <th>Trạng thái</th>
                    <th>Action</th>

                </tr>
        </table>
    </div>
    <!-- Modal order info -->
    <div id="order-modal" class="modal fade text-center" tabindex="-1">
        <div class="modal-dialog">
            <div class="modal-content" style="width: 800px;">
                <div class="modal-header">
                    <h5 class="modal-title">Order Detail!</h5>
                    <button type="button" class="close" data-dismiss="modal">&times;</button>
                </div>
                <!-- Modal body -->
                <div class="modal-body">
                    <div class="form-group row">
                        <div class="col-md-2">
                            <label for="">Order Code</label>
                        </div>
                        <div class="col-md-10">
                            <input id="inp-ordercode" class="form-control" type="text">
                        </div>
                    </div>
                    <div class="form-group row">
                        <div class="col-md-2">
                            <label for="">Pizza Size</label>
                        </div>
                        <div class="col-md-10">
                            <select id="select-pizzasize" class="form-control"></select>
                        </div>
                    </div>
                    <div class="form-group row">
                        <div class="col-md-2">
                            <label for="">Đường kính</label>
                        </div>
                        <div class="col-md-10">
                            <input id="inp-duongkinh" class="form-control" type="text">
                        </div>
                    </div>
                    <div class="form-group row">
                        <div class="col-md-2">
                            <label for="">Sườn</label>
                        </div>
                        <div class="col-md-10">
                            <input id="inp-suon" class="form-control" type="text">
                        </div>
                    </div>
                    <div class="form-group row">
                        <div class="col-md-2">
                            <label for="">Salad</label>
                        </div>
                        <div class="col-md-10">
                            <input id="inp-salad" class="form-control" type="text">
                        </div>
                    </div>
                    <div class="form-group row">
                        <div class="col-md-2">
                            <label for="">Pizza Type</label>
                        </div>
                        <div class="col-md-10">
                            <input id="inp-pizzatype" class="form-control" type="text">
                        </div>
                    </div>
                    <div class="form-group row">
                        <div class="col-md-2">
                            <label for="">ID Voucher</label>
                        </div>
                        <div class="col-md-10">
                            <input id="inp-idvoucher" class="form-control" type="text">
                        </div>
                    </div>
                    <div class="form-group row">
                        <div class="col-md-2">
                            <label for="">Thành tiền</label>
                        </div>
                        <div class="col-md-10">
                            <input id="inp-thanhtien" class="form-control" type="text">
                        </div>
                    </div>
                    <div class="form-group row">
                        <div class="col-md-2">
                            <label for="">Giảm giá</label>
                        </div>
                        <div class="col-md-10">
                            <input id="inp-giamgia" class="form-control" type="text">
                        </div>
                    </div>
                    <div class="form-group row">
                        <div class="col-md-2">
                            <label for="">Loại đồ uống</label>
                        </div>
                        <div class="col-md-10">
                            <select id="select-drink" class="form-control"></select>
                        </div>
                    </div>
                    <div class="form-group row">
                        <div class="col-md-2">
                            <label for="">Số lượng nước uống</label>
                        </div>
                        <div class="col-md-10">
                            <input id="inp-soluongdrink" class="form-control" type="text">
                        </div>
                    </div>
                    <div class="form-group row">
                        <div class="col-md-2">
                            <label for="">Họ và tên</label>
                        </div>
                        <div class="col-md-10">
                            <input id="inp-hoten" class="form-control" type="text">
                        </div>
                    </div>
                    <div class="form-group row">
                        <div class="col-md-2">
                            <label for="">Email</label>
                        </div>
                        <div class="col-md-10">
                            <input id="inp-email" class="form-control" type="text">
                        </div>
                    </div>
                    <div class="form-group row">
                        <div class="col-md-2">
                            <label for="">Số điện thoại</label>
                        </div>
                        <div class="col-md-10">
                            <input id="inp-phone" class="form-control" type="text">
                        </div>
                    </div>
                    <div class="form-group row">
                        <div class="col-md-2">
                            <label for="">Địa chỉ</label>
                        </div>
                        <div class="col-md-10">
                            <input id="inp-address" class="form-control" type="text">
                        </div>
                    </div>
                    <div class="form-group row">
                        <div class="col-md-2">
                            <label for="">Lời nhắn</label>
                        </div>
                        <div class="col-md-10">
                            <input id="inp-message" class="form-control" type="text">
                        </div>
                    </div>
                    <div class="form-group row">
                        <div class="col-md-2">
                            <label for="">Ngày order</label>
                        </div>
                        <div class="col-md-10">
                            <input id="inp-orderday" class="form-control" type="text">
                        </div>
                    </div>
                    <div class="form-group row">
                        <div class="col-md-2">
                            <label for="">Ngày chỉnh sửa</label>
                        </div>
                        <div class="col-md-10">
                            <input id="inp-updatedate" class="form-control" type="text">
                        </div>
                    </div>
                    <div class="form-group row">
                        <div class="col-sm-6 form-group">
                            <button id="btn-confirm" class="btn btn-warning col-sm-12">Confirm</button>
                        </div>
                        <div class="col-sm-6 form-group">
                            <button id="btn-cancel" class="btn btn-danger col-sm-12">Cancel</button>
                        </div>
                    </div>
                </div>
            </div>
        </div>

</body>

</html>